/*
 * Paraschiv Alexandru Cosmin
   Grupa 334CC
 */

#include "lcd.h"


#include <avr/io.h>
#include <util/delay.h>
#include <stdlib.h>



void buton(void) {
	/* Setez pinul PB0 ca intrare. */
	DDRB &= ~(1 << PB0);
	DDRB &= ~(1 << PB1);

	/* Activez rezistenta de pull-up pentru pinul PB0. */
	PORTB |= (1 << PB0);
	PORTB |= (1 << PB1);
	/* Setez pinul PC0 ca iesire. */
	DDRA |= (1 << PA0);
	DDRB |= (1 << PB4);	
	DDRA |= (1 << PA2);
	DDRB |= (1 << PB5);
	DDRA |= (1 << PA3);
	DDRB |= (1 << PB3);
	DDRB |= (1 << PB6);
	DDRA |= (1 << PA4);
	
	/* Sting L1 ED-ul. */
	//PORTA &= ~(1 << PA0);
	//PORTB &= ~(1 << PB4);

	
		/* Daca butonul este apasat. */
		if ((PINB & (1 << PB0)) == 1){
			
			//sting semaforul rosu pentru pietoni
			//PORTA |= (1 << PA0);
			//_delay_ms(50);
			//aprind semaforul verde pentru pietoni
			//PORTB &= ~(1 << PB5);
			//sting semaforul verde pentru masini
			//PORTA |= (1 << PA3);
			//aprind semaforul rosu pentru masini
			//PORTB &= ~(1 << PB3);
			
			
		}	
			
		if ((PINB & (1 << PB1)) == 1){
			
			
		
			//sting semaforul rosu pentru pietoni
			PORTB |= (1 << PB4);
			_delay_ms(50);
			//aprind semaforul verde pentru pietoni
			//PORTA &= ~(1 << PA2);			
			//sting semaforul verde pentru masini
			//PORTB |= (1 < PB6);
			//aprind semaforul rosu pentru masini
			//PORTA &= ~(1 << PA4);			
	}
	
}

/*Galben intermitent doar daca este apasat butonul PB0*/
void galbenintermitent(void){
	
	
	DDRA |= (1 << PA1);
	DDRB |= (1 << PB7);
	
	DDRB &= ~(1 << PB0);
	PORTB |= (1 << PB0);
	
	 
	while(1) {
        
		if((PINB & (1 << PB0)) == 0){
			
		PORTA &= ~(1 << PA1);
		PORTB &= ~(1 << PB7);
		_delay_ms(1000);
		PORTA |= (1 << PA1);
		PORTB |= (1 << PB7);
		_delay_ms(200);
	}
	}

}

/*Stare 2 semafor*/
void semaforgalben(void){
	
	/*Stare 2 de schimbare pe galben*/
	DDRA |= (1 << PA1);
	PORTA |= (1 << PA1);
	
	DDRB |= (1 << PB7);
	PORTB |= (1 << PB7);
	
	//aprindere	semafor galben
	PORTA &= ~(1 << PA1);
	PORTB &= ~(1 << PB7);
		
	

}
/*Sting starea 2*/
void closesemaforgalben(void){

	DDRA |= (1 << PA1);	
	DDRB |= (1 << PB7);
	
	
	PORTA |= (1 << PA1);
	PORTB |= (1 << PB7);

}

/*Stare 1 semafor*/
void semafornormal1(void){

	//rosu pietoni 1; PR1->PR2	
	DDRA |= (1 << PA0);
	
	//verde semafor 1; V1->V2 	
	DDRA |= (1 << PA3);
		
	//rosu semafor 2; R3->R4	
	DDRB |= (1 << PB3);
	
	
	//verde pietoni 2; PV3->PV4	
	DDRB |= (1 << PB5);
	
	
	//aprindere semafor 1
	PORTA &= ~(1 << PA0);
	PORTA &= ~(1 << PA3);
	PORTB &= ~(1 << PB3);
	PORTB &= ~(1 << PB5);
	
	
 
}

/*Sting starea 1*/
void closesemafor1(void){

	DDRA |= (1 << PA0);	
	DDRA |= (1 << PA3);	
	DDRB |= (1 << PB3);	
	DDRB |= (1 << PB5);
	
	
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA3);
	PORTB |= (1 << PB3);
	PORTB |= (1 << PB5);
	
		
	

}

/*Stare 3 semafor*/
void semafornormal2(void){

	//verde pietoni 1; PV1 -> PV2
	DDRA |= (1 << PA2);
	//PORTA |= (1 << PA2);
	
	//rosu semafor 1; R1->R2
	DDRA |= (1 << PA4);
	//PORTA |= (1 << PA4);
	
	//verde semafor 2; V3->V4
	DDRB |= (1 << PB6);
	//PORTB |= (1 << PB6);
	
	//rosu pietoni; PR1->PR2
	DDRB |= (1 << PB4);
	//PORTB |= (1 << PB4);
	
	
	//aprindere semafor 2
	PORTA &= ~(1 << PA2);
	PORTA &= ~(1 << PA4);		
	PORTB &= ~(1 << PB6);
	PORTB &= ~(1 << PB4);
		

}

/*Sting starea 3*/
void closesemafor2(void){

	DDRA |= (1 << PA2);
	DDRA |= (1 << PA4);
	DDRB |= (1 << PB6);
	DDRB |= (1 << PB4);
	
	
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA4);		
	PORTB |= (1 << PB6);
	PORTB |= (1 << PB4);
	
	
}

int main()
{
    
	int i;
	char buf[10];
	LCD_init();
		
	while(1){
	//printez starea 1 a semaforului pe lcd
	LCD_printAt(0, "Stare 1:");
	semafornormal1();
	for(i=0;i < 8;i++){
		int a = 8-i;
		
		itoa (a,buf,10);
		LCD_printAt(10,buf);
		_delay_ms(1000);
	}
	closesemafor1();
	_delay_ms(50);	
	
	//printez starea 2 a semaforului pe lcd
	LCD_printAt(0, "Stare 2:");
	semaforgalben();
	itoa(1, buf, 10);
	LCD_printAt(10, buf);	
	_delay_ms(800);	
	closesemaforgalben();	
	_delay_ms(50);
	
	//printez starea 3 a semaforului pe lcd
	LCD_printAt(0, "Stare 3:");
	semafornormal2();
	for(i=0;i < 8;i++){
		int a = 8-i;
		
		itoa (a,buf,10);
		LCD_printAt(10,buf);
		_delay_ms(1000);
	}
	closesemafor2();
	_delay_ms(2000);
	
	//printez starea de intermitent pe lcd
	LCD_printAt(0, "Intermitent             ");
	galbenintermitent();	
	
	}
	
	
    return 0;
}

